import {
  changePrimary,
  useGraphQueryResult,
} from '@graphpolaris/shared/data-access/store';
import { useTheme } from '@mui/material';
import React, { useEffect, useState } from 'react';
import ReactJSONView from 'react-json-view';
import { useDispatch } from 'react-redux';
import styles from './rawjsonvis.module.scss';

/* eslint-disable-next-line */
export interface RawJSONVisProps {
  loading?: boolean;
}

export const RawJSONVis = React.memo((props: RawJSONVisProps) => {
  const graphQueryResult = useGraphQueryResult();
  const dispatch = useDispatch();
  const theme = useTheme();
  console.log('update rawjson');

  useEffect(() => {
    console.log('update rawjson useEffect');
  }, [graphQueryResult]);

  useEffect(() => {
    return () => {
      console.log('unloaded RawJSONVis');
    };
  }, []);

  const loading = props.loading;

  return (
    <>
      <input
        onChange={(v) =>
          dispatch(changePrimary({ main: v.currentTarget.value }))
        }
        type="color"
        name="head"
        value={theme.palette.primary.main}
      />
      {loading && (
        <div
          style={{
            marginTop: '40px',
            paddingLeft: '30px',
          }}
        >
          <svg
            className={styles.rotating}
            xmlns="http://www.w3.org/2000/svg"
            viewBox="0 0 50 50"
          >
            <circle className={styles.ring} cx="25" cy="25" r="20"></circle>
            <circle className={styles.ball} cx="25" cy="5" r="3.5"></circle>
          </svg>
        </div>
      )}
      {!loading && (
        <div style={{ overflowY: 'auto' }}>
          <div
            style={{
              marginTop: '40px',
              paddingLeft: '30px',
            }}
          >
            <ReactJSONView
              src={graphQueryResult}
              collapsed={1}
              quotesOnKeys={false}
              displayDataTypes={false}
            />
          </div>
        </div>
      )}
    </>
  );
});
